/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011 by Meika Sugimoto
 * 
 *  嵭Ԥϡʲ (1)(4) ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ǤǺۤˤϡۤȼɥȡѼԥ
 *      ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ̵
 *      ڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ǤʤǺۤˤϡΤ줫ξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡޤ
 *      ܥեȥΥ桼ޤϥɥ桼Τʤͳ˴
 *      ᤫ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪФ
 *  ŬޤơʤݾڤԤʤޤܥեȥ
 *  ˤľŪޤϴŪʤ»˴ؤƤ⡤Ǥ
 *  ʤ
 * 
 */
/*
 *  ٥ȥե饰ǽ
 */


#include "kernel_impl.h"
#include "check.h"
#include "eventflag.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_SET_FLG_ENTER
#define LOG_SET_FLG_ENTER(flgid, setptn)
#endif /* LOG_SET_FLG_ENTER */

#ifndef LOG_SET_FLG_LEAVE
#define LOG_SET_FLG_LEAVE(ercd)
#endif /* LOG_SET_FLG_LEAVE */

#ifndef LOG_ISET_FLG_ENTER
#define LOG_ISET_FLG_ENTER(flgid, setptn)
#endif /* LOG_ISET_FLG_ENTER */

#ifndef LOG_ISET_FLG_LEAVE
#define LOG_ISET_FLG_LEAVE(ercd)
#endif /* LOG_ISET_FLG_LEAVE */

#ifndef LOG_CLR_FLG_ENTER
#define LOG_CLR_FLG_ENTER(flgid, clrptn)
#endif /* LOG_CLR_FLG_ENTER */

#ifndef LOG_CLR_FLG_LEAVE
#define LOG_CLR_FLG_LEAVE(ercd)
#endif /* LOG_CLR_FLG_LEAVE */

#ifndef LOG_POL_FLG_ENTER
#define LOG_POL_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn)
#endif /* LOG_POL_FLG_ENTER */

#ifndef LOG_POL_FLG_LEAVE
#define LOG_POL_FLG_LEAVE(ercd, flgptn)
#endif /* LOG_POL_FLG_LEAVE */



/* ٥ȥե饰IDID󥪥եåȤؤѴޥ */
#define INDEX_FLG(flgid)	((uint_t)((flgid) - TMIN_FLGID))

#ifdef TOPPERS_iniflg

void initialize_eventflag(void)
{
	uint_t i;
	
	for(i = 0U ; i < tmax_flgid ; i++)
	{
		/* ӥåȥѥν */
		flgcb_flgptn[i] = flginib_iflgptn[i];
	}
}

#endif /* TOPPERS_iniflg */

/*
 *  ٥ȥե饰郎ΩƤ뤫Υå
 */
Inline bool_t
check_flg_cond(FLGPTN curptn , FLGPTN waiptn, MODE wfmode)
{
	bool_t flgset = false;
	
	if ((wfmode & TWF_ORW) != 0U)
	{
		if((curptn & waiptn) != 0U)
		{
			flgset = true;
		}
	}
	else	/* (wfmode & TWF_ANDW) != 0U  */
	{
		if((curptn & waiptn) == waiptn)
		{
			flgset = true;
		}
	}
	
	return (flgset);
}

/*
 *  ٥ȥե饰Υå
 */
#ifdef TOPPERS_set_flg

ER
set_flg(ID flgid, FLGPTN setptn)
{
	ER		ercd;
	
	LOG_SET_FLG_ENTER(flgid, setptn);
	CHECK_TSKCTX_UNL();
	CHECK_FLGID(flgid);
	
	t_lock_cpu();
	flgcb_flgptn[INDEX_FLG(flgid)] |= setptn;
	ercd = E_OK;
	t_unlock_cpu();
	
  error_exit:
	LOG_SET_FLG_LEAVE(ercd);
	return(ercd);
}


#endif /* TOPPERS_set_flg */

/*
 *  ٥ȥե饰Υåȡ󥿥ƥѡ
 */
#ifdef TOPPERS_iset_flg

ER
iset_flg(ID flgid, FLGPTN setptn)
{
	ER		ercd;
	
	LOG_ISET_FLG_ENTER(flgid, setptn);
	CHECK_INTCTX_UNL();
	CHECK_FLGID(flgid);
	
	i_lock_cpu();
	flgcb_flgptn[INDEX_FLG(flgid)] |= setptn;
	ercd = E_OK;
	i_unlock_cpu();
	
  error_exit:
	LOG_ISET_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_iset_flg */

/*
 *  ٥ȥե饰Υꥢ
 */
#ifdef TOPPERS_clr_flg

ER
clr_flg(ID flgid, FLGPTN clrptn)
{
	ER		ercd;
	
	LOG_CLR_FLG_ENTER(flgid, clrptn);
	CHECK_TSKCTX_UNL();
	CHECK_FLGID(flgid);
	
	t_lock_cpu();
	flgcb_flgptn[INDEX_FLG(flgid)] &= clrptn; 
	ercd = E_OK;
	t_unlock_cpu();
	
  error_exit:
	LOG_CLR_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_clr_flg */


/*
 *  ٥ȥե饰Ԥʥݡ󥰡
 */
#ifdef TOPPERS_pol_flg

ER
pol_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
{
	ER		ercd;
	int_t	index;
	
	LOG_POL_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn);
	CHECK_TSKCTX_UNL();
	CHECK_FLGID(flgid);
	CHECK_PAR(waiptn != 0U);
	CHECK_PAR(wfmode == TWF_ORW || wfmode == TWF_ANDW);
	
	t_lock_cpu();
	
	index = INDEX_FLG(flgid);
	
	if (check_flg_cond(flgcb_flgptn[index], waiptn, wfmode)) {
		ercd = E_OK;
		*p_flgptn = flgcb_flgptn[index];

		if((flginib_atr[index] & TA_CLR) != 0U)
		{
			flgcb_flgptn[index] = 0U;
		}
	}
	else {
		ercd = E_TMOUT;
	}
	t_unlock_cpu();

  error_exit:
	LOG_POL_FLG_LEAVE(ercd, *p_flgptn);
	return(ercd);
}

#endif /* TOPPERS_pol_flg */


