/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 *  Copyright (C) 2010-2012 by Meika Sugimoto
 * 
 *  嵭Ԥϡʲ (1)(4) ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ǤǺۤˤϡۤȼɥȡѼԥ
 *      ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ̵
 *      ڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ǤʤǺۤˤϡΤ줫ξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡޤ
 *      ܥեȥΥ桼ޤϥɥ桼Τʤͳ˴
 *      ᤫ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪФ
 *  ŬޤơʤݾڤԤʤޤܥեȥ
 *  ˤľŪޤϴŪʤ»˴ؤƤ⡤Ǥ
 *  ʤ
 * 
 */

/*
 *		TOPPERS/SSPͥ ɸإåե
 *
 *  TOPPERS/SSPͥ뤬ݡȤ륵ӥȡɬפʥǡ
 *  ޥޤإåե롥
 *
 *  ֥Υե뤫餳Υե򥤥󥯥롼ɤ
 *  ϡTOPPERS_MACRO_ONLYƤˤꡤޥʳ
 *  褦ˤʤäƤ롥
 *
 *  Υե򥤥󥯥롼ɤ˥󥯥롼ɤƤ٤ե
 *  Ϥʤ
 */

#ifndef TOPPERS_KERNEL_H
#define TOPPERS_KERNEL_H

/*
 *	TOPPERS̤Υǡޥ
 */
#include <t_stddef.h>

/*
 *  åȰ¸
 */
#include "target_kernel.h"
#ifndef TOPPERS_MACRO_ONLY

/*
 *  ǡ
 */

/*
 *  ӥåȥѥ䥪ֹ֥η
 */
typedef	uint_t			INTNO;		/* ֹ */
typedef	uint_t			INHNO;		/* ߥϥɥֹ */
typedef	uint_t			EXCNO;		/* CPU㳰ϥɥֹ */
typedef unsigned long	FLGPTN;		/* ٥ȥե饰ѥ */


/*
 *  ñ̤η
 */
typedef void	(*TASK)(intptr_t exinf);
typedef void	(*ISR)(intptr_t exinf);
typedef void	(*INTHDR)(void);
typedef void	(*EXCHDR)(void *p_excinf);
typedef void	(*INIRTN)(intptr_t exinf);
typedef void	(*TERRTN)(intptr_t exinf);
typedef void	(*CYCHDR)(intptr_t exinf);
typedef void	(*ALMHDR)(intptr_t exinf);

/*
 *  ΰݤΤη
 */
#ifndef TOPPERS_STK_T
#define TOPPERS_STK_T	intptr_t
#endif /* TOPPERS_STK_T */
typedef	TOPPERS_STK_T	STK_T;	/* åΰݤ뤿η */


/*
 *  ӥ
 */

/*
 *  ǽ
 */
extern ER		act_tsk(ID tskid);
extern ER		iact_tsk(ID tskid);

/*
 *  Ʊ̿ǽ
 */

/* ǡ塼 */
extern ER psnd_dtq(ID dtqid, intptr_t data);
extern ER ipsnd_dtq(ID dtqid, intptr_t data);
extern ER prcv_dtq(ID dtqid, intptr_t *p_data);

/* ٥ȥե饰 */
extern ER set_flg(ID flgid, FLGPTN setptn);
extern ER iset_flg(ID flgid, FLGPTN setptn);
extern ER clr_flg(ID flgid, FLGPTN clrptn);
extern ER pol_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn);

/*
 *  ƥִǽ
 */
extern ER		loc_cpu(void);
extern ER		iloc_cpu(void);
extern ER		unl_cpu(void);
extern ER		iunl_cpu(void);
extern ER		dis_dsp(void);
extern ER		ena_dsp(void);
extern bool_t	sns_ctx(void);
extern bool_t	sns_loc(void);
extern bool_t	sns_dsp(void);
extern bool_t	sns_dpn(void);
extern bool_t	sns_ker(void);
extern ER		ext_ker(void);

/*
 *  ߴǽ
 */
extern ER		dis_int(INTNO intno);
extern ER		ena_int(INTNO intno);

/*
 *  ϥɥ鵡ǽ
 */
extern ER		sta_cyc(ID cycid);
extern ER		stp_cyc(ID cycid);

/*
 *  顼ϥɥ鵡ǽ
 */
extern ER		sta_alm(ID almid , RELTIM almtim);
extern ER		stp_alm(ID almid);

/*
 *  ƥǽ
 */
extern ER		get_tim(SYSTIM *p_systim);

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ֥°
 */
#define TA_RSTR			UINT_C(0x04)	/* 󥿥 */

#define TA_CLR			UINT_C(0x04)	/* ٥ȥե饰Υꥢ */

#define TA_ACT			UINT_C(0x02)	/* ư줿֤ */

#define TA_STA			UINT_C(0x02)	/* ϥɥư֤ */

#define TA_NONKERNEL	UINT_C(0x02)	/* ͥγ */

#define TA_ENAINT		UINT_C(0x01)	/* ׵ػߥե饰򥯥ꥢ */
#define TA_EDGE			UINT_C(0x02)	/* åȥꥬ */

/*
 *  ӥư⡼ɤ
 */
#define TWF_ORW			UINT_C(0x01)	/* ٥ȥե饰ORԤ */
#define TWF_ANDW		UINT_C(0x02)	/* ٥ȥե饰ANDԤ */

/*
 *  ¾
 */
#define TSK_SELF		0			/*  */
#define TSK_NONE		0			/* 륿ʤ */

#define TPRI_INI		0			/* εưͥ */

#define TIPM_ENAALL		0			/* ͥ٥ޥ */

/*
 *  ȥޥ
 */

/*
 *  ͥ٤ϰ
 */
#define TMIN_TPRI		1			/* ͥ٤κǾ͡ʺǹ͡*/
#ifndef TMAX_TPRI
	#define TMAX_TPRI		16			/* ͥ٤κ͡ʺ͡*/
#elif (TMAX_TPRI != 8) && (TMAX_TPRI != 16)
	#error "TMAX_TPRI must defined 8 or 16."
#endif	/* TMAX_TPRI */

#define TMIN_ISRPRI		1			/* ߥӥ롼ͥ٤κǾ */
#ifndef TMAX_ISRPRI
	#define TMAX_ISRPRI		16			/* ߥӥ롼ͥ٤κ */
#elif (TMAX_ISRPRI != 8) && (TMAX_ISRPRI != 16)
	#error "TMAX_ISRPRI must defined 8 or 16."
#endif	/* TMAX_ISRPRI */

/*
 *  С
 */
#define TKERNEL_MAKER	UINT_C(0x0118)	/* ͥΥ᡼ */
#define TKERNEL_PRID	UINT_C(0x0007)	/* ͥμֹ */
#define TKERNEL_SPVER	UINT_C(0xf511)	/* ͥͤΥСֹ */
#define TKERNEL_PRVER	UINT_C(0x1021)	/* ͥΥСֹ */

/*
 *  塼󥰲κ
 */
#define TMAX_ACTCNT		UINT_C(1)		/* ư׵ᥭ塼󥰿κ */

/*
 *  ӥåȥѥΥӥåȿ
 */
#ifndef TBIT_FLGPTN                     /* ٥ȥե饰Υӥåȿ */
#define TBIT_FLGPTN             (sizeof(FLGPTN) * CHAR_BIT)
#endif /* TBIT_FLGPTN */

/*
 *  ΰݤΤΥޥ
 *
 *  ʲTOPPERS_COUNT_SZTOPPERS_ROUND_SZϡunit2ζҾǤ
 *  뤳ȤꤷƤ롥
 */
#ifndef TOPPERS_COUNT_SZ
#define TOPPERS_COUNT_SZ(sz, unit)	(((sz) + (unit) - 1) / (unit))
#endif /* TOPPERS_COUNT_SZ */
#ifndef TOPPERS_ROUND_SZ
#define TOPPERS_ROUND_SZ(sz, unit)	(((sz) + (unit) - 1) & ~((unit) - 1))
#endif /* TOPPERS_ROUND_SZ */

#define COUNT_STK_T(sz)		TOPPERS_COUNT_SZ((sz), sizeof(STK_T))
#define ROUND_STK_T(sz)		TOPPERS_ROUND_SZ((sz), sizeof(STK_T))


#endif /* TOPPERS_KERNEL_H */
